Index: CMakeLists.txt
===================================================================
--- CMakeLists.txt	(revision 236)
+++ CMakeLists.txt	(revision 141)
@@ -1,101 +1,5 @@
-CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
-
-#EXECUTE_PROCESS(
-#  COMMAND hg id -i
-#  OUTPUT_VARIABLE HG_REVISION
-#  OUTPUT_STRIP_TRAILING_WHITESPACE)
-
-SET(PROJECT_NAME "LEMON")
-SET(PROJECT_VERSION_MAJOR "0")
-SET(PROJECT_VERSION_MINOR "99")
-SET(PROJECT_VERSION_PATCH "0")
-SET(PROJECT_VERSION
-  "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
-
-PROJECT(${PROJECT_NAME})
-
-SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
-
-INCLUDE(FindDoxygen)
-INCLUDE(FindGhostscript)
-
-ENABLE_TESTING()
-
-ADD_SUBDIRECTORY(lemon)
-ADD_SUBDIRECTORY(demo)
-ADD_SUBDIRECTORY(doc)
-ADD_SUBDIRECTORY(test)
-
-IF(WIN32)
-  INSTALL(FILES ${CMAKE_SOURCE_DIR}/cmake/nsis/lemon.ico
-    DESTINATION bin)
-ENDIF(WIN32)
-
-IF(WIN32)
-  SET(CPACK_PACKAGE_NAME ${PROJECT_NAME})
-  SET(CPACK_PACKAGE_VENDOR
-    "EGRES - Egervary Research Group on Combinatorial Optimization")
-  SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY
-    "LEMON - Library of Efficient Models and Optimization in Networks")
-  SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE")
-
-  SET(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
-  SET(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
-  SET(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})
-  SET(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
-
-  SET(CPACK_PACKAGE_INSTALL_DIRECTORY
-    "${PROJECT_NAME} ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
-  SET(CPACK_PACKAGE_INSTALL_REGISTRY_KEY
-    "${PROJECT_NAME} ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
-
-  # Variables to generate a component-based installer.
-  #SET(CPACK_COMPONENTS_ALL headers library html_documentation)
-
-  #SET(CPACK_COMPONENT_HEADERS_DISPLAY_NAME "C++ headers")
-  #SET(CPACK_COMPONENT_LIBRARY_DISPLAY_NAME "Static library")
-  #SET(CPACK_COMPONENT_HTML_DOCUMENTATION_DISPLAY_NAME "HTML documentation")
-
-  #SET(CPACK_COMPONENT_HEADERS_DESCRIPTION
-  #  "C++ header files for use with the LEMON library")
-  #SET(CPACK_COMPONENT_LIBRARY_DESCRIPTION
-  #  "Static library used to build programs with LEMON")
-  #SET(CPACK_COMPONENT_HTML_DOCUMENTATION_DESCRIPTION
-  #  "Doxygen generated documentation")
-
-  #SET(CPACK_COMPONENT_HEADERS_DEPENDS library)
-
-  #SET(CPACK_COMPONENT_HEADERS_GROUP "Development")
-  #SET(CPACK_COMPONENT_LIBRARY_GROUP "Development")
-  #SET(CPACK_COMPONENT_HTML_DOCUMENTATION_GROUP "Documentation")
-
-  #SET(CPACK_COMPONENT_GROUP_DEVELOPMENT_DESCRIPTION
-  #  "Components needed to develop software using LEMON")
-  #SET(CPACK_COMPONENT_GROUP_DOCUMENTATION_DESCRIPTION
-  #  "Documentation of LEMON")
-
-  #SET(CPACK_ALL_INSTALL_TYPES Full Developer)
-
-  #SET(CPACK_COMPONENT_HEADERS_INSTALL_TYPES Developer Full)
-  #SET(CPACK_COMPONENT_LIBRARY_INSTALL_TYPES Developer Full)
-  #SET(CPACK_COMPONENT_HTML_DOCUMENTATION_INSTALL_TYPES Full)
-
-  SET(CPACK_GENERATOR "NSIS")
-  SET(CPACK_NSIS_MUI_ICON "${CMAKE_SOURCE_DIR}/cmake/nsis/lemon.ico")
-  SET(CPACK_NSIS_MUI_UNIICON "${CMAKE_SOURCE_DIR}/cmake/nsis/uninstall.ico")
-  #SET(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/cmake/nsis\\\\installer.bmp")
-  SET(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\lemon.ico")
-  SET(CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY} ${PROJECT_NAME}")
-  SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\lemon.cs.elte.hu")
-  SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\lemon.cs.elte.hu")
-  SET(CPACK_NSIS_CONTACT "lemon-user@lemon.cs.elte.hu")
-  SET(CPACK_NSIS_CREATE_ICONS_EXTRA "
-    CreateShortCut \\\"$SMPROGRAMS\\\\$STARTMENU_FOLDER\\\\Documentation.lnk\\\" \\\"$INSTDIR\\\\doc\\\\index.html\\\"
-    ")
-  SET(CPACK_NSIS_DELETE_ICONS_EXTRA "
-    !insertmacro MUI_STARTMENU_GETFOLDER Application $MUI_TEMP
-    Delete \\\"$SMPROGRAMS\\\\$MUI_TEMP\\\\Documentation.lnk\\\"
-    ")
-
-  INCLUDE(CPack)
-ENDIF(WIN32)
+project (LEMON)
+enable_testing ()
+add_subdirectory (lemon)
+add_subdirectory (demo)
+add_subdirectory (test)
Index: Makefile.am
===================================================================
--- Makefile.am	(revision 227)
+++ Makefile.am	(revision 146)
@@ -9,6 +9,5 @@
 	m4/lx_check_glpk.m4 \
 	m4/lx_check_soplex.m4 \
-	CMakeLists.txt \
-	cmake
+	CMakeLists.txt
 
 pkgconfigdir = $(libdir)/pkgconfig
Index: demo/CMakeLists.txt
===================================================================
--- demo/CMakeLists.txt	(revision 225)
+++ demo/CMakeLists.txt	(revision 141)
@@ -1,13 +1,13 @@
-INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
+include_directories (${LEMON_SOURCE_DIR})
 
-LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/lemon)
+link_directories (${LEMON_BINARY_DIR}/lemon)
 
-SET(DEMOS
+set (DEMOS
   arg_parser_demo
   graph_to_eps_demo
   lgf_demo)
 
-FOREACH(DEMO_NAME ${DEMOS})
-  ADD_EXECUTABLE(${DEMO_NAME} ${DEMO_NAME}.cc)
-  TARGET_LINK_LIBRARIES(${DEMO_NAME} lemon)
-ENDFOREACH(DEMO_NAME)
+foreach (DEMO_NAME ${DEMOS})
+  add_executable (${DEMO_NAME} ${DEMO_NAME}.cc)
+  target_link_libraries (${DEMO_NAME} lemon)
+  endforeach (DEMO_NAME)
Index: demo/graph_to_eps_demo.cc
===================================================================
--- demo/graph_to_eps_demo.cc	(revision 220)
+++ demo/graph_to_eps_demo.cc	(revision 211)
@@ -32,4 +32,5 @@
 
 #include<lemon/list_graph.h>
+#include<lemon/graph_utils.h>
 #include<lemon/graph_to_eps.h>
 #include<lemon/math.h>
Index: doc/Doxyfile.in
===================================================================
--- doc/Doxyfile.in	(revision 226)
+++ doc/Doxyfile.in	(revision 212)
@@ -16,6 +16,6 @@
 INLINE_INHERITED_MEMB  = NO
 FULL_PATH_NAMES        = YES
-STRIP_FROM_PATH        = "@abs_top_srcdir@"
-STRIP_FROM_INC_PATH    = "@abs_top_srcdir@"
+STRIP_FROM_PATH        = @abs_top_srcdir@
+STRIP_FROM_INC_PATH    = @abs_top_srcdir@
 SHORT_NAMES            = YES
 JAVADOC_AUTOBRIEF      = NO
@@ -81,11 +81,11 @@
 # configuration options related to the input files
 #---------------------------------------------------------------------------
-INPUT                  = "@abs_top_srcdir@/doc" \
-                         "@abs_top_srcdir@/lemon" \
-                         "@abs_top_srcdir@/lemon/bits" \
-                         "@abs_top_srcdir@/lemon/concepts" \
-                         "@abs_top_srcdir@/demo" \
-                         "@abs_top_srcdir@/tools" \
-                         "@abs_top_srcdir@/test/test_tools.h"
+INPUT                  = @abs_top_srcdir@/doc \
+                         @abs_top_srcdir@/lemon \
+                         @abs_top_srcdir@/lemon/bits \
+                         @abs_top_srcdir@/lemon/concepts \
+                         @abs_top_srcdir@/demo \
+                         @abs_top_srcdir@/tools \
+                         @abs_top_srcdir@/test/test_tools.h
 INPUT_ENCODING         = UTF-8
 FILE_PATTERNS          = *.h \
@@ -97,11 +97,11 @@
 EXCLUDE_PATTERNS       = 
 EXCLUDE_SYMBOLS        = 
-EXAMPLE_PATH           = "@abs_top_srcdir@/demo" \
-                         "@abs_top_srcdir@/LICENSE" \
-                         "@abs_top_srcdir@/doc"
+EXAMPLE_PATH           = @abs_top_srcdir@/demo \
+                         @abs_top_srcdir@/LICENSE \
+                         @abs_top_srcdir@/doc
 EXAMPLE_PATTERNS       = 
 EXAMPLE_RECURSIVE      = NO
-IMAGE_PATH             = "@abs_top_srcdir@/doc/images" \
-                         "@abs_top_builddir@/doc/gen-images"
+IMAGE_PATH             = @abs_top_srcdir@/doc/images \
+                         @abs_top_builddir@/doc/gen-images
 INPUT_FILTER           = 
 FILTER_PATTERNS        = 
@@ -146,5 +146,5 @@
 DISABLE_INDEX          = NO
 ENUM_VALUES_PER_LINE   = 4
-GENERATE_TREEVIEW      = NO
+GENERATE_TREEVIEW      = YES
 TREEVIEW_WIDTH         = 250
 #---------------------------------------------------------------------------
Index: doc/Makefile.am
===================================================================
--- doc/Makefile.am	(revision 227)
+++ doc/Makefile.am	(revision 156)
@@ -8,6 +8,5 @@
 	doc/mainpage.dox \
 	doc/namespaces.dox \
-	doc/html \
-	doc/CMakeLists.txt
+	doc/html
 
 DOC_EPS_IMAGES18 = \
Index: doc/groups.dox
===================================================================
--- doc/groups.dox	(revision 236)
+++ doc/groups.dox	(revision 210)
@@ -326,5 +326,5 @@
 maximum cardinality matching.
 
-LEMON contains the next algorithms:
+Lemon contains the next algorithms:
 - \ref lemon::MaxBipartiteMatching "MaxBipartiteMatching" Hopcroft-Karp
   augmenting path algorithm for calculate maximum cardinality matching in
@@ -477,10 +477,10 @@
 
 /**
-@defgroup lemon_io LEMON Input-Output
+@defgroup lemon_io Lemon Input-Output
 @ingroup io_group
-\brief Reading and writing \ref lgf-format "LEMON Graph Format".
+\brief Reading and writing \ref lgf-format "Lemon Graph Format".
 
 This group describes methods for reading and writing
-\ref lgf-format "LEMON Graph Format".
+\ref lgf-format "Lemon Graph Format".
 */
 
Index: doc/lgf.dox
===================================================================
--- doc/lgf.dox	(revision 236)
+++ doc/lgf.dox	(revision 212)
@@ -22,5 +22,5 @@
 
 
-\page lgf-format LEMON Graph Format (LGF)
+\page lgf-format Lemon Graph Format (LGF)
 
 The \e LGF is a <em>column oriented</em>
Index: lemon/CMakeLists.txt
===================================================================
--- lemon/CMakeLists.txt	(revision 225)
+++ lemon/CMakeLists.txt	(revision 141)
@@ -1,18 +1,2 @@
-INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
-
-ADD_LIBRARY(lemon
-  arg_parser.cc
-  base.cc
-  color.cc
-  random.cc)
-
-INSTALL(
-  TARGETS lemon
-  ARCHIVE DESTINATION lib
-  COMPONENT library)
-
-INSTALL(
-  DIRECTORY . bits concepts
-  DESTINATION include/lemon
-  COMPONENT headers
-  FILES_MATCHING PATTERN "*.h")
+include_directories (${LEMON_SOURCE_DIR})
+add_library (lemon arg_parser.cc base.cc color.cc random.cc)
Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 220)
+++ lemon/Makefile.am	(revision 195)
@@ -25,5 +25,4 @@
 	lemon/concept_check.h \
         lemon/counter.h \
-	lemon/core.h \
         lemon/dfs.h \
         lemon/dijkstra.h \
@@ -31,4 +30,5 @@
 	lemon/error.h \
         lemon/graph_to_eps.h \
+	lemon/graph_utils.h \
 	lemon/kruskal.h \
 	lemon/lgf_reader.h \
@@ -50,9 +50,10 @@
         lemon/bits/bezier.h \
 	lemon/bits/default_map.h \
-        lemon/bits/enable_if.h \
 	lemon/bits/graph_extender.h \
+        lemon/bits/invalid.h \
 	lemon/bits/map_extender.h \
 	lemon/bits/path_dump.h \
 	lemon/bits/traits.h \
+        lemon/bits/utility.h \
 	lemon/bits/vector_map.h
 
Index: lemon/assert.h
===================================================================
--- lemon/assert.h	(revision 218)
+++ lemon/assert.h	(revision 212)
@@ -238,5 +238,5 @@
 
 #    if LEMON_ENABLE_DEBUG
-#      define LEMON_DEBUG(exp, msg)                                     \
+#      define LEMON_DEBUG(exp, msg)
          (static_cast<void> (!!(exp) ? 0 : (                            \
            LEMON_ASSERT_HANDLER(__FILE__, __LINE__,                     \
Index: lemon/base.cc
===================================================================
--- lemon/base.cc	(revision 220)
+++ lemon/base.cc	(revision 209)
@@ -21,5 +21,5 @@
 
 #include<lemon/tolerance.h>
-#include<lemon/core.h>
+#include<lemon/bits/invalid.h>
 namespace lemon {
 
